﻿<Serializable()> _
Public MustInherit Class clsDrawingObject

    Friend MustOverride Sub Paint(ByVal g As Graphics)

    Public ConnectionPainted As Boolean = False

    Private m_isSelected As Boolean
    Public Property isSelected() As Boolean
        Get
            Return m_isSelected
        End Get
        Set(ByVal value As Boolean)
            If value = False Then m_MouseOffset = New Point(0, 0)
            m_isSelected = value
        End Set
    End Property

    Private m_isHovered As Boolean
    Public Property isHovered() As Boolean
        Get
            Return m_isHovered
        End Get
        Set(ByVal value As Boolean)
            If value = False Then m_MouseOffset = New Point(0, 0)
            m_isHovered = value
        End Set
    End Property

    Private m_isHighlighted As Boolean
    Public Property isHighlighted() As Boolean
        Get
            Return m_isHighlighted
        End Get
        Set(ByVal value As Boolean)
            If value = False Then m_MouseOffset = New Point(0, 0)
            m_isHighlighted = value
        End Set
    End Property

    Private m_Owner As clsDrawingPanel
    Public Property Owner() As clsDrawingPanel
        Get
            Return m_Owner
        End Get
        Set(ByVal value As clsDrawingPanel)
            m_Owner = value
        End Set
    End Property

    Private m_Bounds As Rectangle
    Public Property Bounds() As Rectangle
        Get
            Return m_Bounds
        End Get
        Set(ByVal value As Rectangle)
            m_Bounds = value
        End Set
    End Property

    Private m_DrawingBounds As Rectangle
    Public Property DrawingBounds() As Rectangle
        Get
            Return m_DrawingBounds
        End Get
        Set(ByVal value As Rectangle)
            m_DrawingBounds = value
        End Set
    End Property

    Private m_Location As Point
    Public Property Location() As Point
        Get
            Return m_Location
        End Get
        Set(ByVal value As Point)
            m_Location = value
            m_Bounds = New Rectangle(value, m_Bounds.Size)
        End Set
    End Property

    Private m_OldLocation As Point
    Public Property OldLocation() As Point
        Get
            Return m_OldLocation
        End Get
        Set(ByVal value As Point)
            m_OldLocation = value
            m_Bounds = New Rectangle(value, m_Bounds.Size)
        End Set
    End Property

    Private m_ConnectedTo As clsDrawingObject
    Public Property ConnectedTo() As clsDrawingObject
        Get
            Return m_ConnectedTo
        End Get
        Set(ByVal value As clsDrawingObject)
            m_ConnectedTo = value
        End Set
    End Property

    Private m_Name As String
    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal value As String)
            m_Name = value
        End Set
    End Property

    Private m_MouseOffset As Point
    Public ReadOnly Property MouseOffset() As Point
        Get
            m_MouseOffset = New Point(Math.Abs(m_Owner.MousePos.X - Me.Bounds.Location.X), Math.Abs(m_Owner.MousePos.Y - Me.Bounds.Location.Y))
            Return m_MouseOffset
        End Get
    End Property

    Public ReadOnly Property Mittelpunkt(Position As Point) As Point
        Get
            Return New Point(CInt(Position.X + Me.Bounds.Width / 2), CInt(Position.Y + Me.Bounds.Height / 2))
        End Get
    End Property

    Public Sub New(Owner As clsDrawingPanel)
        m_Owner = Owner
    End Sub

End Class
